-------------------------------------------------------------------------------
--
--		Massive New Krew - "S.U.M.M.E.R."
--		Bubble Tea Invitational 2.5 Trailer
--		
--		Author: 	Telperion
--		Date: 		2017-03-24
--		Target:		SM5.0.12+
--
-------------------------------------------------------------------------------
--
--		THIS
--		IS
--
--		SUMMER
--
-------------------------------------------------------------------------------

local circumvention = false
if circumvention then
	return Def.ActorFrame {}
end

local LetsGetSilly = true

local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local BPS = 60 / 150
local ofs = 0.009
local overtime = 0
local visualOffset = -0.01
local fgmsg = 0
local checked = false
local plr = {nil, nil}

local PI = math.pi
local LOG2 = math.log(2.0)
local DEG_TO_RAD = math.pi / 180.0

--
-- 		some funktion !
--
function SideSign(i) return (i == 2) and 1 or -1 end

function RangeScale(t, inLower, inUpper, outLower, outUpper)
	local ti = (t - inLower) / (inUpper - inLower)
	return outLower + ti * (outUpper - outLower)
end

function RangeClamp(t, outLower, outUpper)
	local ti = t
	ti = (ti < outLower) and outLower or ti
	ti = (ti > outUpper) and outUpper or ti
	return ti
end

function ArrayMax(a)
	if #a == 0 then return nil end
	if #a == 1 then return a[1] end
	local m = a[1]
	for _,v in pairs(a) do
		if v > m then m = v end
	end
	return m
end

function ArrayMin(a)
	if #a == 0 then return nil end
	if #a == 1 then return a[1] end
	local m = a[1]
	for _,v in pairs(a) do
		if v < m then m = v end
	end
	return m
end

function Whomst(act)
	return tonumber(string.match(act:GetName(), "P([0-9]+)"))
end

function Whichst(act)
	return tonumber(string.match(act:GetName(), "_([0-9]+)"))
end

-- Lua with that stealth shallow copy. fuck thou and the referential horse thee rode in on
function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end




local SummerTrailer = Def.ActorFrame {
	InitCommand = function(self)
		self:fov(70)
			:vanishpoint(sw/2, sh/4)			
			:SetDrawByZPosition(true)
	end,
	OnCommand = function(self)
		plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		SCREENMAN:GetTopScreen():SetDrawByZPosition(true)


		local hamburger = SCREENMAN:GetTopScreen()
		if hamburger:GetScreenType() == "ScreenType_Gameplay" then
			hamburger:GetChild("Overlay" ):decelerate(4.0 / BPS):diffusealpha(0.0)
			hamburger:GetChild("Underlay"):decelerate(4.0 / BPS):diffusealpha(0.0)
		end
				
		local playersFound = 0
		for pn = 1,2 do
			pv = plr[pn]
			if pv then
				pv:GetChild("Combo"):hibernate(1573)
			end
			
			pops = GAMESTATE:GetPlayerState("PlayerNumber_P"..pn):GetPlayerOptions("ModsLevel_Song")
			pops:FailSetting('FailType_Off')
		end

		self:sleep(1573)
	end
};



-------------------------------------------------------------------------------
--
-- 		Proxies (as usual)
--

--
--	Player proxies (one apiece)
--
for pn = 1,2 do
	SummerTrailer[#SummerTrailer + 1] = Def.ActorFrame {	
		Name = "ProxyP"..pn.."Outer",
		Def.ActorFrame {	
			Name = "ProxyP"..pn.."Inner",
			Def.ActorProxy {					
				Name = "ProxyP"..pn,
				InitCommand = function(self)
					self:aux( Whomst(self) )
						:visible(false)
				end,
				BeginCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then self:SetTarget(McCoy) else self:hibernate(1573) end
				end,
				OnCommand=function(self)
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end,
				RecenterProxyMessageCommand=function(self)					
					local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
					if McCoy then 
						self:xy(-McCoy:GetX(), -McCoy:GetY())
						self:GetParent():xy(McCoy:GetX(), McCoy:GetY())
					end
				end
			},
			InitCommand = function(self)
--				self:aux( Whichst(self) )
			end,
			OnCommand = function(self)
			end,
		},
		InitCommand = function(self)
--			self:aux( Whichst(self) )
		end,
		OnCommand = function(self)
			self:xy(0, 0)
				:z(1)
				:decelerate(4.0 / BPS)
				:diffusealpha(0)
		end,
	}
end



--
--	Judgment proxies
--
for pn = 1,2 do
	SummerTrailer[#SummerTrailer + 1] = Def.ActorProxy {
		Name = "JudgeP"..pn.."Proxy",
		InitCommand = function(self)
			self:aux( Whomst(self) )
		end,
		BeginCommand = function(self)
			local McCoy = SCREENMAN:GetTopScreen():GetChild('PlayerP'..self:getaux())
			if McCoy then 
				local McJudge = McCoy:GetChild('Judgment')
				self:SetTarget(McJudge)
				McJudge:visible(false)
			else 
				self:hibernate(1573)
			end
		end,
		OnCommand = function(self)
			local p = self:GetParent()
						  :GetChild('ProxyP'..self:getaux().."Outer")
						  :GetChild('ProxyP'..self:getaux().."Inner")
			
			self:xy(p:GetX(), sh/2)
		end,
	}
end

--
-- 		Proxies (as usual)
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
-- 		Pretty polygonal backdrops
--
function CalcPolyRing(n, radIn, radOut, colorChoice)
	local verts = {}
	
	--
	-- 1--3--5--7-...
	-- |  |  |  |
	-- 2--4--6--8-...
	--
	for pointIndex = 0, n do
		local px = math.cos(2*PI / n * pointIndex)
		local py = math.sin(2*PI / n * pointIndex)
		verts[#verts+1] = {
			{radOut * px, radOut * py, 0},
			colorChoice,
			{0, 0}
		}
		verts[#verts+1] = {
			{radIn  * px, radIn  * py, 0},
			colorChoice,
			{0, 0}
		}
	end
	
	return verts
end

function RGB2HSV(rgbColor)
	-- RGB: [0, 1]
	-- HSV: [0, 360) (hue), 
	--		[0, 1] (saturation, value)
	local r, g, b, alpha = unpack(rgbColor)

	local cmin = ArrayMin({r, g, b})
	local cmax = ArrayMax({r, g, b})
	local rr = RangeScale(r, cmin, cmax, 0.0, 1.0)
	local gg = RangeScale(g, cmin, cmax, 0.0, 1.0)
	local bb = RangeScale(b, cmin, cmax, 0.0, 1.0)

	local h = 0
	if rr >= 1 then h = RangeScale(gg - bb, -1, 1, -60.0,  60.0) end
	if gg >= 1 then h = RangeScale(bb - rr, -1, 1,  60.0, 180.0) end
	if bb >= 1 then h = RangeScale(rr - gg, -1, 1, 180.0, 300.0) end
	if  h <  0 then h = h + 360 end

	local s = cmax - cmin
	local v = (cmax + cmin) / 2.0

	local hsvColor = {h, s, v, alpha}
	-- Trace("("..r..", "..g..", "..b..") RGB -> HSV ("..h..", "..s..", "..v..")")
	-- Trace("^^ min/max ("..cmin..", "..cmax..") ^^ ("..rr..", "..gg..", "..bb..") Scaled RGB ^^")
	return hsvColor
end

function LightnessOf(rgbColor)
	return 0.11 * rgbColor[1] + 0.59 * rgbColor[2] + 0.30 * rgbColor[3]
end

function HSV2RGB(hsvColor)
	local h, s, v, alpha = unpack(hsvColor)

	h = h % 360

	local r, g, b
	if     h <  60 then
		r = 1.0
		g = RangeScale(h,   0,  60, 0.0, 1.0)
		b = 0.0
	elseif h < 120 then
		r = RangeScale(h,  60, 120, 1.0, 0.0)
		g = 1.0
		b = 0.0
	elseif h < 180 then
		r = 0.0
		g = 1.0
		b = RangeScale(h, 120, 180, 0.0, 1.0)
	elseif h < 240 then
		r = 0.0
		g = RangeScale(h, 180, 240, 1.0, 0.0)
		b = 1.0
	elseif h < 300 then
		r = RangeScale(h, 240, 300, 0.0, 1.0)
		g = 0.0
		b = 1.0
	else --h < 360
		r = 1.0
		g = 0.0
		b = RangeScale(h, 300, 360, 1.0, 0.0)
	end

	if v > 0.5 then
		r = 1.0 - (1.0 - v) * (1.0 - r) * 2
		g = 1.0 - (1.0 - v) * (1.0 - g) * 2
		b = 1.0 - (1.0 - v) * (1.0 - b) * 2
	else
		r = 2 * v * r
		g = 2 * v * g
		b = 2 * v * b
	end

	local cmin = ArrayMin({r, g, b})
	local cmax = ArrayMax({r, g, b})
	local ss = 1.0 - s
	local cminSat = (cmin + ss*cmax) / (1.0 + ss)
	local cmaxSat = (cmax + ss*cmin) / (1.0 + ss)
	r = RangeScale(r, cmin, cmax, cminSat, cmaxSat)
	g = RangeScale(g, cmin, cmax, cminSat, cmaxSat)
	b = RangeScale(b, cmin, cmax, cminSat, cmaxSat)

	local rgbColor = {r, g, b, alpha}
	-- Trace("("..h..", "..s..", "..v..") HSV -> RGB ("..r..", "..g..", "..b..")")
	return rgbColor
end

function PalettePicker(paletteStyle, paletteSeed)
	-- Palette styles:
	-- 0	Corresponding Triad
	--		[1]
	--		[2], or [1] +/- 30~90 deg
	--		[1] - ([2] - [1])
	-- 1	Complementary Triad (not implemented)
	--		[1]
	--		[2], or [1] +/- 30~90 deg
	--		([1] + [2])/2 + 180 deg
	-- 2	Four Corner Quad
	--		[1]
	--		[2], or [1] +/- 30~90 deg
	--		[1] + 180 deg
	--		[2] + 180 deg
	-- 3	Correspomplementary Quad
	--		[1]
	--		[2], or [1] +/- 30~90 deg
	--		[1] - ([2] - [1])
	--		[1] + 180 deg
	-- Accepts {r, g, b} or {r, g, b, alpha} color as the seed.
	-- Returns {r, g, b, alpha} colors as the palette.
	if #paletteSeed < 4 then
		paletteSeed[4] = 1.0
	end

	if paletteStyle == 0 then
		shift = 15 + 30 * math.random()
		baseHSV = RGB2HSV(paletteSeed)
		return {
			HSV2RGB({baseHSV[1]        , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] + shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] - shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			}
	elseif paletteStyle == 1 then
		-- Mirror corresponding triad for now.
		shift = 15 + 30 * math.random()
		baseHSV = RGB2HSV(paletteSeed)
		return {
			HSV2RGB({baseHSV[1]        , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] + shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] - shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			}
	elseif paletteStyle == 2 then
		shift = 30 + 60 * math.random()
		baseHSV = RGB2HSV(paletteSeed)
		return {
			HSV2RGB({baseHSV[1]              , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] + shift      , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] +  180       , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] + shift + 180, baseHSV[2], baseHSV[3], baseHSV[4]}),
			}
	elseif paletteStyle == 3 then
		shift = 15 + 30 * math.random()
		baseHSV = RGB2HSV(paletteSeed)
		return {
			HSV2RGB({baseHSV[1]        , baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] + shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] - shift, baseHSV[2], baseHSV[3], baseHSV[4]}),
			HSV2RGB({baseHSV[1] +  180 , baseHSV[2], baseHSV[3], baseHSV[4]}),
			}
	elseif paletteStyle == -1 then
		return {paletteSeed}
	else
		-- passthrough
		return paletteSeed
	end
end

local maxBackdropRadius = 1.5 * math.sqrt(sw*sw + sh*sh)
local radiusStepLo = 0.015
local radiusStepHi = 0.075
function CreatePolyBackdrop(n, paletteStyle, paletteSeed)
	--
	--
	--
	--
	local backdropAMVs = Def.ActorFrame {
		Name = "PolyBackdropFrame",
		InitCommand = function(self)
			self:visible(true)
				:diffusealpha(0.0)
				:rotationz(math.random() * 360)
				:xy(0, 0)
		end
	}

	local palette = PalettePicker(paletteStyle, paletteSeed)
	local paletteRotation = #palette - 1
	local totalRadius = 0
	local lastColor = 0
	local ringIndex = 1
	while totalRadius < maxBackdropRadius do
		-- Trace("Ring "..ringIndex..": R_in = "..totalRadius)
		thisStep = (radiusStepLo + (radiusStepHi - radiusStepLo) * math.random()) * maxBackdropRadius
		if ringIndex == 1 then
			thisStep = thisStep * 0.5
		end
		local thisRing = CalcPolyRing(n, totalRadius, totalRadius + thisStep, palette[lastColor + 1])
		if paletteRotation > 0 then
			lastColor = (lastColor + math.random(1, paletteRotation)) % #palette
		end

		backdropAMVs[#backdropAMVs + 1] = Def.ActorMultiVertex {
			Name = "PolyBackdropAMV_"..ringIndex,
			InitCommand = function(self)
				self:xy(0, 0)
					:SetVertices(thisRing)
					:SetDrawState{First = 1, 
								  Num = (n+1) * 2,
								  Mode = "DrawMode_QuadStrip"}
			end
		}
		ringIndex = ringIndex + 1
		totalRadius = totalRadius + thisStep
	end

	return backdropAMVs
end

--
-- 		Pretty polygonal backdrops
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
-- 		Actual instatiations of shit
--

SummerTrailer[#SummerTrailer + 1] = Def.Quad {
	InitCommand = function(self)
		self:SetWidth(sw)
			:SetHeight(sh)
			:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
			:diffuse(0, 0, 0, 1)
	end
}


local describeFungah = {
	"sightread tournament",
	"he's finally inserted\na creative name here",
	"surprise! it's\n20 versions of\nThe Funk Is",
	"~thirty dollars~",
	"(air quotes)\n\"washed up\"",
	"time for another\nround of Jell-O shots!"
}

local describeTelperion = {
	"sightread tournament\n+ mods",
	"not this shit again",
	"preventing memes\nfrom remaining dreams\nsince 2016",
	"the double chart\nwas better",
	"windeu insomnia\nuksrtale mawaru",
	"18 naked cowboys\nin the showers\nat Ram Ranch",
	"don't actually\nuch his bepis"
}

local describeBuzzibee = {
	"non-music gaming",
	"probably off on a\ncasual half-marathon",
	"already pregaming\nfor Rage Cage",
	"he's got nice abs",
	"you think mods are neat\nwell. have you tried\nhis risotto",
	"really good at\ndoing a spook of you"
}

local GingerDescriptions = {
	describeFungah,
	describeTelperion,
	describeBuzzibee
}

local GingerPalettes = {
	{
		{0.00, 0.30, 1.00, 1.0},
		{0.00, 0.00, 0.90, 1.0},
		{0.00, 0.00, 0.30, 1.0},
		{0.00, 0.00, 0.00, 1.0}
	},
	{
		{0.90, 0.25, 0.00, 1.0},
		{0.18, 0.72, 0.00, 1.0},
		{0.00, 0.45, 0.60, 1.0},
		{0.00, 0.15, 0.00, 1.0}
	},
	{
		{0.90, 0.00, 0.00, 1.0},
		{0.20, 0.00, 0.00, 1.0},
		{0.50, 0.60, 1.00, 1.0},
		{0.00, 0.10, 0.40, 1.0}
	}
}


-- Introductions
local afTrioRotate = (math.random() < 0.5) and math.random(5, 10) or -math.random(5, 10)
afTrio = Def.ActorFrame{
	Name = "AFTrio",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
	end,
	EmphasizeTrioMessageCommand = function(self)
		self:rotationz(afTrioRotate * -0.5)
	end,
	EmphasizeTrio2MessageCommand = function(self)
		self:rotationz(afTrioRotate)
	end,
}
local trioOffset = math.random() * PI / 1.5
for textIndex=1,3 do
	local rememberIndex = textIndex
	afTrio[#afTrio + 1] = Def.Sprite {
		Texture = "fairweather/trio.png",
		InitCommand = function(self)
			self:xy(0, 0)
				:diffuse(rememberIndex==1 and 1 or 0, 
						 rememberIndex==2 and 1 or 0,
						 rememberIndex==3 and 1 or 0, 0)
		end,
		EmphasizeTrioMessageCommand = function(self)
			self:diffusealpha(0.5)
				:zoom(0.9)
				:blend("BlendMode_Add")
				:queuecommand("StepA")
		end,
		StepACommand = function(self)
			self:decelerate(4.0 / BPS)
				:xy(sh * 0.05 * math.cos(trioOffset + rememberIndex * PI / 1.5),
					sh * 0.05 * math.sin(trioOffset + rememberIndex * PI / 1.5))
				:zoom(0.85)
				:queuecommand("StepB")
		end,
		StepBCommand = function(self)
			self:accelerate(3.0 / BPS)
				:xy(sh * 0.30 * math.cos(trioOffset + rememberIndex * PI / 1.5),
					sh * 0.30 * math.sin(trioOffset + rememberIndex * PI / 1.5))
				:diffusealpha(0)
				:zoom(0.8)
		end
	}
end
afTrio[#afTrio + 1] = Def.Sprite {
	Texture = "fairweather/trio.png",
	InitCommand = function(self)
		self:xy(0, 0)
			:diffuse(1, 1, 1, 0)
	end,
	EnterTrioMessageCommand = function(self)
		self:zoom(0.6)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:decelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(0.85)
			:queuecommand("StepB")
	end,
	StepBCommand = function(self)
		self:linear(14.5 / BPS)
			:zoom(0.95)
			:queuecommand("StepC")
	end,
	StepCCommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(0.0)
			:zoom(1.5)
	end
}
SummerTrailer[#SummerTrailer + 1] = afTrio



local afTandemRotate = (math.random() < 0.5) and math.random(5, 10) or -math.random(5, 10)
afTandem = Def.ActorFrame{
	Name = "AFTandem",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
	end,
	EmphasizeTandemMessageCommand = function(self)
		self:rotationz(afTandemRotate * -0.5)
	end,
	EmphasizeTandem2MessageCommand = function(self)
		self:rotationz(afTandemRotate)
	end,
}
local tandemOffset = math.random() * PI / 1.5
for textIndex=1,3 do
	local rememberIndex = textIndex
	afTandem[#afTandem + 1] = Def.Sprite {
		Texture = "fairweather/tandem.png",
		InitCommand = function(self)
			self:xy(0, 0)
				:diffuse(rememberIndex==1 and 1 or 0, 
						 rememberIndex==2 and 1 or 0,
						 rememberIndex==3 and 1 or 0, 0)
		end,
		EmphasizeTandemMessageCommand = function(self)
			self:diffusealpha(0.5)
				:zoom(0.9)
				:blend("BlendMode_Add")
				:queuecommand("StepA")
		end,
		StepACommand = function(self)
			self:decelerate(4.0 / BPS)
				:xy(sh * 0.05 * math.cos(tandemOffset + rememberIndex * PI / 1.5),
					sh * 0.05 * math.sin(tandemOffset + rememberIndex * PI / 1.5))
				:zoom(0.85)
				:queuecommand("StepB")
		end,
		StepBCommand = function(self)
			self:accelerate(3.0 / BPS)
				:xy(sh * 0.30 * math.cos(tandemOffset + rememberIndex * PI / 1.5),
					sh * 0.30 * math.sin(tandemOffset + rememberIndex * PI / 1.5))
				:diffusealpha(0)
				:zoom(0.8)
		end
	}
end
afTandem[#afTandem + 1] = Def.Sprite {
	Texture = "fairweather/tandem.png",
	InitCommand = function(self)
		self:xy(0, 0)
			:diffuse(1, 1, 1, 0)
	end,
	EnterTandemMessageCommand = function(self)
		self:zoom(0.6)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:decelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(0.85)
			:queuecommand("StepB")
	end,
	StepBCommand = function(self)
		self:linear(14.5 / BPS)
			:zoom(0.95)
			:queuecommand("StepC")
	end,
	StepCCommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(0.0)
			:zoom(1.5)
	end
}
SummerTrailer[#SummerTrailer + 1] = afTandem




-- The three hosts and roles
local moveParams = {}
local BackdropsContainer = Def.ActorFrame {
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
	end
}
local TextsContainer = Def.ActorFrame {
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
	end
}
for bdIndex = 1,3 do
	local rememberIndex = bdIndex
	moveParams[bdIndex] = (math.random() - 0.5) * 60

	local bopdrop = CreatePolyBackdrop(math.random(5, 9), -2, GingerPalettes[rememberIndex])
	bopdrop.DropTopMessageCommand = function(self, messageArgs)
		if messageArgs[1] == rememberIndex then
			self:GetParent():rotationz(moveParams[rememberIndex])
			self:xy(sw * 0.5, sh * 0.5)
				:queuecommand("StepA")
		end
	end
	bopdrop.StepACommand = function(self)
		self:decelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:xy(sw * 0.3, sh * 0.3)
			:queuecommand("StepB")
	end
	bopdrop.StepBCommand = function(self)
		self:linear(8 / BPS)
			:xy(sw * 0.2, sh * 0.2)
			:queuecommand("StepC")
	end
	bopdrop.StepCCommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(0.0)
			:xy(0, 0)
	end
	BackdropsContainer[#BackdropsContainer + 1] = bopdrop


	local namedrop = Def.Sprite {
		Name="Name_"..rememberIndex,
		Texture="fairweather/name-"..rememberIndex..".png",
		InitCommand = function(self)
			self:xy(0, sh * (LetsGetSilly and -0.15 or -0.1))
				:zoom(1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end
	}
	namedrop.DropTopMessageCommand = function(self, messageArgs)
		if messageArgs[1] == rememberIndex then
			self:GetParent():rotationz(moveParams[rememberIndex] / 2)
			self:x(sw * 0.2)
				:queuecommand("StepA")
		end
	end
	namedrop.StepACommand = function(self)
		self:decelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:x(sw * 0.02)
			:queuecommand("StepB")
	end
	namedrop.StepBCommand = function(self)
		self:linear(2 / BPS)
			:x(sw * 0)
			:queuecommand("StepC")
	end
	namedrop.StepCCommand = function(self)
		self:linear(2 / BPS)
			:x(sw * -0.02)
			:queuecommand("StepD")
	end
	namedrop.StepDCommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(0.0)
			:x(sw * -0.2)
	end
	TextsContainer[#TextsContainer + 1] = namedrop


	local textdrop = Def.BitmapText {
		Name="Desc_"..rememberIndex,
		Font="_cocogoose 36px.ini",
		InitCommand = function(self)
			local descripts = GingerDescriptions[rememberIndex]

			if LetsGetSilly then
				self:settext(descripts[math.random(2, #descripts)])
			else
				self:settext(descripts[1])
			end

			self:xy(0, sh * (LetsGetSilly and 0.2 or 0.15))
				:zoom(1)
				:diffuse(1.0, 1.0, 1.0, 0.0)
		end
	}
	textdrop.DropTopMessageCommand = function(self, messageArgs)
		if messageArgs[1] == rememberIndex then
			self:GetParent():rotationz(moveParams[rememberIndex] / 2)
			self:x(sw * 0.2)
				:sleep(2.0 / BPS)
				:queuecommand("StepA")
		end
	end
	textdrop.StepACommand = function(self)
		self:decelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:x(sw * 0.02)
			:queuecommand("StepB")
	end
	textdrop.StepBCommand = function(self)
		self:linear(2 / BPS)
			:x(sw * 0)
			:queuecommand("StepC")
	end
	textdrop.StepCCommand = function(self)
		self:linear(2 / BPS)
			:x(sw * -0.02)
			:queuecommand("StepD")
	end
	textdrop.StepDCommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(0.0)
			:x(sw * -0.2)
	end
	TextsContainer[#TextsContainer + 1] = textdrop
end
SummerTrailer[#SummerTrailer + 1] = BackdropsContainer
SummerTrailer[#SummerTrailer + 1] = TextsContainer


-- THIS IS SUMMER
local rotationRate = (math.random() < 0.5) and math.random(6, 12) or -math.random(6, 12)
local bopfill = CreatePolyBackdrop(math.random(5, 9), 2, HSV2RGB({150, 0.95, 0.48}))
bopfill.BackFillMessageCommand = function(self, messageArgs)
	self:xy(0, 0)
		:zoom(0)
		:rotationz(0)
		:diffusealpha(1.0)
		:queuecommand("StepA")
end
bopfill.StepACommand = function(self)
	self:decelerate(1.0 / BPS)
		:diffusealpha(1.0)
		:zoom(0.75)
end
bopfill.BackBounceMessageCommand = function(self, messageArgs)
	self:pulse()
		:effectmagnitude(0.9, 1.1, 0)
		:effectclock("beat")
		:effectoffset(0.0)
		:effectperiod(1.0)		
end
bopfill.KillTheNoiseMessageCommand = function(self)
	self:accelerate(7.0 / BPS)
		:diffusealpha(0.0)
end
SummerTrailer[#SummerTrailer + 1] = Def.ActorFrame {
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)			
	end,
	BackBounceMessageCommand = function(self)
		self:rotationz(GAMESTATE:GetSongBeat() * -rotationRate)
			:spin()
			:effectmagnitude(0, 0, rotationRate)
			:effectclock("beat")
			:effectperiod(1.0)
	end,
	bopfill
}



SummerTrailer[#SummerTrailer + 1] = Def.Sprite {
	Texture = "fairweather/shadow.png",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y - 15)
			:diffuse(1, 1, 1, 0)
	end,
	BackBounceMessageCommand = function(self)
		self:diffusealpha(0.25)
			:effectcolor1(0, 0, 0, 1.0)
			:effectcolor2(1, 1, 1, 1.0)
			:effectclock("bgm")
			:effectoffset(1.0)
			:effectperiod(2.0)
			:glowshift()
	end,
	KillTheNoiseMessageCommand = function(self)
		self:accelerate(7.0 / BPS)
			:diffusealpha(0.0)
	end
}


SummerTrailer[#SummerTrailer + 1] = Def.Sprite {
	Texture = "fairweather/row-A.png",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, 5 + 64)
			:diffuse(1, 1, 1, 0)
	end,
	RowAMessageCommand = function(self)
		self:zoom(0.8)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(1.0)
	end,
	KillTheNoiseMessageCommand = function(self)
		self:accelerate(7.0 / BPS)
			:diffusealpha(0.0)
	end
}
SummerTrailer[#SummerTrailer + 1] = Def.Sprite {
	Texture = "fairweather/row-B.png",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, 75 + 64)
			:diffuse(1, 1, 1, 0)
	end,
	RowBMessageCommand = function(self)
		self:zoom(0.8)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(1.0)
	end,
	KillTheNoiseMessageCommand = function(self)
		self:accelerate(7.0 / BPS)
			:diffusealpha(0.0)
	end
}
SummerTrailer[#SummerTrailer + 1] = Def.Sprite {
	Texture = "fairweather/row-C.png",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, 135 + 128)
			:diffuse(1, 1, 1, 0)
	end,
	RowCMessageCommand = function(self)
		self:zoom(0.8)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(1.0)
	end,
	KillTheNoiseMessageCommand = function(self)
		self:accelerate(7.0 / BPS)
			:diffusealpha(0.0)
	end
}
SummerTrailer[#SummerTrailer + 1] = Def.Sprite {
	Texture = "fairweather/row-D.png",
	InitCommand = function(self)
		self:xy(SCREEN_CENTER_X, 335 + 64)
			:diffuse(1, 1, 1, 0)
	end,
	RowDMessageCommand = function(self)
		self:zoom(0.8)
			:queuecommand("StepA")
	end,
	StepACommand = function(self)
		self:accelerate(0.5 / BPS)
			:diffusealpha(1.0)
			:zoom(1.0)
	end,
	KillTheNoiseMessageCommand = function(self)
		self:accelerate(7.0 / BPS)
			:diffusealpha(0.0)
	end
}






--
-- 		Actual instantiations of shit
--
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
--
-- 		This is where the shit will be happening.
--

local messageList = {
	{  4.00, "RecenterProxy"},

	{  7.50, "EnterTrio"},
	{ 16.00, "EmphasizeTrio"},
	{ 17.00, "EmphasizeTrio2"},

	{ 23.50, "EnterTandem"},
	{ 32.00, "EmphasizeTandem"},
	{ 33.00, "EmphasizeTandem2"},
	
	{ 39.40, "DropTop", {1}},
	{ 47.40, "DropTop", {2}},
	{ 55.40, "DropTop", {3}},
	{ 64.50, "RowA"},
	{ 66.50, "RowB"},
	{ 68.00, "RowC"},
	{ 68.50, "RowD"},
	{ 70.50, "BackFill"},
	{ 72.00, "BackBounce"},

	{128.00, "KillTheNoise"},
}


local gfxHQ = Def.Quad {
	InitCommand = function(self)
		self:SetHeight(6)
			:SetWidth(6)
			:xy(-sw,-sh)
			:visible(false)
	end,
	OnCommand = function(self)
		self:queuecommand("Update")
	end,
	UpdateCommand = function(self)
		-- Most things are determined by beat, believe it or not.		
		overtime = GAMESTATE:GetSongBeat() - visualOffset
		
		-- TODO: this assumes the effect applies over a constant BPM section!!
		BPS = GAMESTATE:GetSongBPS()
		
		-- Who's interesting today?
		if overtime >=   0.0 and not checked then
			for i,v in ipairs(plr) do
				if v then
					v:visible(false)
				end
			end
			
			checked = true
		end
				
		-- Broadcast messages on their own terms.
		while true do
			if fgmsg < #messageList then
				messageBeat, messageName, messageArgs = unpack(messageList[fgmsg+1])
				if overtime >= messageBeat then			
					if messageArgs then
						MESSAGEMAN:Broadcast( messageName, messageArgs )
					else
						MESSAGEMAN:Broadcast( messageName )
					end
					
					fgmsg = fgmsg + 1
				else
					break
				end
			else
				break
			end
		end
		
		-- Wait a bit and then update again!
		self:queuecommand("WaitABit")
	end,
	WaitABitCommand = function(self)
		self:sleep(0.02)
		self:queuecommand("Update")
	end
}
SummerTrailer[#SummerTrailer + 1] = gfxHQ



return SummerTrailer
